package de.intevation.flys.importer;

import java.util.List;

import org.apache.log4j.Logger;

import org.hibernate.Session;
import org.hibernate.Query;

import de.intevation.flys.model.River;
import de.intevation.flys.model.Unit;


public class ImportUnit
{
    private static final Logger log = Logger.getLogger(ImportUnit.class);

    protected String name;

    protected Unit peer;


    public ImportUnit(String name) {
        this.name = name;
    }


    public String getName() {
        return name;
    }


    public void storeDependencies(River river) {
        log.info("store '" + name + "'");
        getPeer(river);
    }

    public Unit getPeer(River river) {
        if (peer == null) {
            Session session = ImporterSession.getInstance().getDatabaseSession();
            Query query = session.createQuery("from Unit where name=:name");
            query.setParameter("name", name);

            List<Unit> units = query.list();
            if (units.isEmpty()) {
                peer = new Unit(name);
                session.save(peer);
            }
            else {
                peer = units.get(0);
            }

        }
        return peer;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
